%bcond_with check

%global packname knitr
%global packver  1.33
%global rlibdir  %{_datadir}/R/library

%global __suggests_exclude ^R\\((JuliaCall|gifski|magick|rgl|sass|webshot)\\)

%global with_loop 0
%global with_suggests 0

Name:             R-%{packname}
Version:          1.33
Release:          1
Summary:          A General-Purpose Package for Dynamic Report Generation in R

License:          GPLv2+
URL:              https://CRAN.R-project.org/package=%{packname}
Source0:          https://cran.r-project.org/src/contrib/%{packname}_%{packver}.tar.gz

BuildArch:        noarch
Recommends:       tex(framed.sty)
Recommends:       tex(listings.sty)
BuildRequires:    R-devel
BuildRequires:    tex(latex)
BuildRequires:    R-evaluate >= 0.10
BuildRequires:    R-highr
BuildRequires:    R-methods
BuildRequires:    R-markdown
BuildRequires:    R-stringr >= 0.6
BuildRequires:    R-yaml >= 2.1.19
BuildRequires:    R-xfun >= 0.21
BuildRequires:    R-tools
%if %{with check}
BuildRequires:    R-testit
BuildRequires:    R-digest
BuildRequires:    R-codetools
BuildRequires:    R-htmlwidgets >= 0.7
BuildRequires:    R-tikzDevice >= 0.10
BuildRequires:    R-tinytex
BuildRequires:    R-png
BuildRequires:    R-jpeg
BuildRequires:    R-xml2 >= 1.2.0
BuildRequires:    R-DBI >= 0.4.1
BuildRequires:    R-showtext
%if %{with_loop}
BuildRequires:    R-formatR
BuildRequires:    R-rmarkdown
%endif
%if %{with_suggests}
BuildRequires:    R-rgl >= 0.95.1201
BuildRequires:    R-webshot
BuildRequires:    R-reticulate >= 1.4
BuildRequires:    R-JuliaCall >= 0.11.1
BuildRequires:    R-magick
BuildRequires:    R-gifski
BuildRequires:    R-httr
BuildRequires:    R-tibble
BuildRequires:    R-sass
BuildRequires:    R-bslib
BuildRequires:    R-ragg
BuildRequires:    R-styler >= 1.2.0
BuildRequires:    lyx
%endif
%endif

%description
Provides a general-purpose tool for dynamic report generation in R using
Literate Programming techniques.


%prep
%setup -q -c -n %{packname}
rm %{packname}/inst/examples/knit-all.R


%build


%install
mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css

mkdir %{buildroot}%{_bindir}
sed -e '1d;2i#!%{_bindir}/Rscript' %{buildroot}%{rlibdir}/%{packname}/bin/knit > %{buildroot}%{_bindir}/knit
chmod --reference=%{buildroot}%{rlibdir}/%{packname}/bin/knit %{buildroot}%{_bindir}/knit
touch -r %{buildroot}%{rlibdir}/%{packname}/bin/knit %{buildroot}%{_bindir}/knit
rm -r %{buildroot}%{rlibdir}/%{packname}/bin


%check
%if %{with check}
export LANG=C.UTF-8
%if ! %{with_suggests} || ! %{with_loop}
export _R_CHECK_FORCE_SUGGESTS_=0
%endif
%if ! %{with_loop}
ARGS=--no-examples
%endif

%{_bindir}/R CMD check %{packname} $ARGS
%endif


%files
%{_bindir}/knit
%dir %{rlibdir}/%{packname}
%doc %{rlibdir}/%{packname}/doc
%doc %{rlibdir}/%{packname}/html
%{rlibdir}/%{packname}/DESCRIPTION
%{rlibdir}/%{packname}/NEWS.Rd
%{rlibdir}/%{packname}/INDEX
%{rlibdir}/%{packname}/NAMESPACE
%{rlibdir}/%{packname}/Meta
%{rlibdir}/%{packname}/R
%{rlibdir}/%{packname}/help
%doc %{rlibdir}/%{packname}/CITATION
%{rlibdir}/%{packname}/demo
%{rlibdir}/%{packname}/examples
%{rlibdir}/%{packname}/misc
%{rlibdir}/%{packname}/opencpu
%{rlibdir}/%{packname}/shiny
%{rlibdir}/%{packname}/themes

%changelog
* Mon May 30 2022 misaka00251 <misaka00251@misakanet.cn> - 1.33-1
- Init package
